"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const asn1js_1 = require("asn1js");
const pvtsutils_1 = require("pvtsutils");
class OctetString extends ArrayBuffer {
    constructor(param) {
        if (typeof param === "number") {
            super(param);
        }
        else {
            if (pvtsutils_1.BufferSourceConverter.isBufferSource(param)) {
                super(param.byteLength);
                const view = new Uint8Array(this);
                view.set(pvtsutils_1.BufferSourceConverter.toUint8Array(param));
            }
            else if (Array.isArray(param)) {
                var array = new Uint8Array(param);
                super(array.length);
                var view = new Uint8Array(this);
                view.set(array);
            }
            else {
                super(0);
            }
        }
    }
    fromASN(asn) {
        if (!(asn instanceof asn1js_1.OctetString)) {
            throw new TypeError("Argument 'asn' is not instance of ASN.1 OctetString");
        }
        return new OctetString(asn.valueBlock.valueHex);
    }
    toASN() {
        return new asn1js_1.OctetString({ valueHex: this });
    }
    toSchema(name) {
        return new asn1js_1.OctetString({ name });
    }
}
exports.OctetString = OctetString;
